Merge commit 'jrollins/master'
authorDaniel Kahn Gillmor <dkg@fifthhorseman.net>
Tue, 17 Jun 2008 18:52:31 +0000 (14:52 -0400)
committerDaniel Kahn Gillmor <dkg@fifthhorseman.net>
Tue, 17 Jun 2008 18:52:31 +0000 (14:52 -0400)
12 files changed:
debian/dirs
debian/monkeysphere.dirs
doc/TODO
etc/monkeysphere.conf
man/man1/monkeysphere-ssh-proxycommand.1
man/man1/monkeysphere.1
man/man8/monkeysphere-server.8
src/common
src/monkeysphere
src/monkeysphere-server
src/monkeysphere-ssh-proxycommand
src/seckey2sshagent [new file with mode: 0755]

index bdf0fe0493caa1a493981746e097ac1c6ba10dc6..b458649fbeef34dc0cc0fa0090fd9f917c1c8b8a 100644 (file)
@@ -1,4 +1,5 @@
 var/cache/monkeysphere
+var/cache/monkeysphere/authorized_keys
 usr/bin
 usr/sbin
 usr/share
index 4604eee9bed268b8a4dbb8173f8a4ea8926028d1..bc8abcf0f51ee7d3dcd1ae7a9b70f464b62c78b1 100644 (file)
@@ -1,4 +1,5 @@
 usr/share/monkeysphere
 var/cache/monkeysphere
+var/cache/monkeysphere/authorized_keys
 etc/monkeysphere
 etc/monkeysphere/authorized_user_ids
index 6125fea3aa4deae2a52f17c10d59a1e2b3a12d4f..905d1980804b8a009ca6c42fa2738f4add79c8b8 100644 (file)
--- a/doc/TODO
+++ b/doc/TODO
@@ -1,6 +1,18 @@
 Next-Steps Monkeysphere Projects:
 ---------------------------------
 
+Handle unknown hosts in such a way that they're not always removed
+   from known_hosts file.  Ask user to lsign the host key?
+
+Handle multiple multiple hostnames (multiple user IDs?) when
+   generating host keys with gen-key.
+
+Make sure alternate ports are handled for known_hosts.
+
+Add environment variables sections to man pages.
+
+Script to import private key into ssh agent.
+
 Provide a friendly interactive UI for marginal or failing client-side
    hostkey verifications.  Handle the common cases smoothly, and
    provide good debugging info for the unusual cases.
index 003ecf689591c2b61440158564afac854a900e88..17c1a14f64927efde45d7b157416523a523d2f63 100644 (file)
@@ -3,9 +3,6 @@
 # This is an sh-style shell configuration file.  Variable names should
 # be separated from their assignements by a single '=' and no spaces.
 
-# authorized_user_ids file
-#AUTHORIZED_USER_IDS=~/.config/monkeysphere/authorized_user_ids
-
 # GPG home directory
 #GNUPGHOME=~/.gnupg
 
 #REQUIRED_HOST_KEY_CAPABILITY="e a"
 #REQUIRED_USER_KEY_CAPABILITY="a"
 
-# Path to user-controlled authorized_keys file to add to
-# Monkeysphere-generated authorized_keys file.
-# To not add any user-controlled file, put "-"
-#USER_CONTROLLED_AUTHORIZED_KEYS=~/.ssh/authorized_keys
-
-# User known_hosts file
-#USER_KNOWN_HOSTS=~/.ssh/known_hosts
+# ssh known_hosts file
+#KNOWN_HOSTS=~/.ssh/known_hosts
 
 # Whether or not to hash the generated known_hosts lines.
 # Should be "true" or "false"
 #HASH_KNOWN_HOSTS=true
+
+# ssh authorized_keys file
+#AUTHORIZED_KEYS=~/.ssh/known_hosts
index 8392ae8317e8631b550b79080857de630a80c9aa..5fabb91af5dce22ac09e4601549eb63bcac561d1 100644 (file)
@@ -19,13 +19,12 @@ or by adding the following line to your ~/.ssh/config script:
 .B ProxyCommand monkeysphere-ssh-proxycommand %h %p
 
 The script is very simple, and can easily be incorporated into other
-ProxyCommand scripts.  All it does is first runs
-
-.B monkeysphere update-known-hosts HOST
-
-and then
-
-.B exec nc HOST PORT
+ProxyCommand scripts.  It first tests to see if the host is in the
+known_hosts file.  If it's not, the CHECK_KEYSERVER variable is set to
+true and "update-known_hosts" is run for the host to check for a host
+key for that host.  If the host is found in the known_hosts file,
+CHECK_KEYSERVER is set to false and "update-known_hosts" is run to
+update from the local keychain.
 
 Run the following command for more info:
 
index 95f1e593252c79cd5ce15d4750b99e456e6c3a28..a5b422c7578c5fcfce0690a3ca3bd3524840c90b 100644 (file)
@@ -24,25 +24,23 @@ for authentication and encryption of ssh connection.
 .B update-known_hosts [HOST]...
 Update the known_hosts file.  For each specified host, gpg will be
 queried for a key associated with the host URI (see HOST URIs),
-querying a keyserver if none is found in the user's keychain. search
-for a gpg key for the host in the Web of Trust.  If a key is found, it
-will be added to the host_keys cache (see KEY CACHES) and any ssh keys
-for the host will be removed from the user's known_hosts file.  If the
-found key is acceptable (see KEY ACCEPTABILITY), then the host's gpg
-key will be added to the known_hosts file.  If no gpg key is found for
-the host, then nothing is done.  If no hosts are specified, all hosts
-listed in the known_hosts file will be processed.  `k' may be used in
-place of `update-known_hosts'.
+querying a keyserver if specified.  If a key is found, it will be
+converted to an ssh key, and any matching ssh keys will be removed
+from the user's known_hosts file.  If the found key is acceptable (see
+KEY ACCEPTABILITY), then the key will be updated and re-added to the
+known_hosts file.  If no gpg key is found for the host, then nothing
+is done.  If no hosts are specified, all hosts listed in the
+known_hosts file will be processed.  `k' may be used in place of
+`update-known_hosts'.
 .TP
 .B update-userids [USERID]...
 Add/update a user ID to the authorized_user_ids file.  The user IDs
 specified should be exact matches to OpenPGP user IDs.  For each
 specified user ID, gpg will be queried for a key associated with that
-user ID, querying a keyserver if none is found in the user's keychain.
-If a key is found, it will be added to the user_keys cache (see KEY
-CACHES) and the user ID will be added to the user's
-authorized_user_ids file (if it wasn't already present).  `u' may be
-used in place of `update-userids'.
+user ID, querying a keyserver if specified.  If a key is found, the
+user ID will be added to the user's authorized_user_ids file (if it
+wasn't already present).  `u' may be used in place of
+`update-userids'.
 .TP
 .B remove-userids [USERID]...
 Remove a user ID from the authorized_user_ids file.  The user IDs
@@ -50,11 +48,15 @@ specified should be exact matches to OpenPGP user IDs.  `r' may be
 used in place of `remove-userids'.
 .TP
 .B update-authorized_keys
-Update the monkeysphere authorized_keys file.  The monkeysphere
-authorized_keys file will be regenerated from the valid keys in the
-user_key cache, and the user's independently controlled
-authorized_keys file (usually ~/.ssh/authorized_keys).  `a' may be
-used in place of `update-authorized_keys'.
+Update the monkeysphere authorized_keys file.  For each user ID in the
+user's authorized_user_ids file, gpg will be queried for keys
+associated with that user ID, querying a keyserver if specified.  If a
+key is found, it will be converted to an ssh key, and any matching ssh
+keys will be removed from the user's authorized_keys file.  If the
+found key is acceptable (see KEY ACCEPTABILITY), then the key will be
+updated and re-added to the authorized_keys file.  If no gpg key is
+found for the user ID, then nothing is done.  `a' may be used in place
+of `update-authorized_keys'.
 .TP
 .B gen-subkey KEYID
 Generate an `a` capable subkey.  For the primary key with the
@@ -83,21 +85,6 @@ the "authentication" ("a") capability flag.
 .B validity
 The key must be "fully" valid, and must not be expired or revoked.
 
-.SH KEY CACHES
-
-Monkeysphere keeps track of keys in key cache directories.  The files
-in the cache are named with the format "USERID_HASH.PUB_KEY_ID", where
-USERID_HASH is a hash of the exact OpenPGP user ID, and PUB_KEY_ID is
-the key ID of the primary key.  If the user/key ID combo exists in the
-Web of Trust but is not acceptable, then the file is empty.  If the
-primary key has at least one acceptable sub key, then an ssh-style
-key, converted from the OpenPGP key, of all acceptable subkeys will be
-stored in the cache file, one per line.  known_hosts style key lines
-will be stored in the host_keys cache files, and authorized_keys style
-key lines will be stored in the user_keys cache files.  OpenPGP keys
-are converted to ssh-style keys with the openpgp2ssh utility (see `man
-openpgp2ssh').
-
 .SH FILES
 
 .TP
@@ -113,12 +100,6 @@ addition to the authorized_keys file.
 .TP
 ~/.config/monkeysphere/authorized_keys
 Monkeysphere generated authorized_keys file.
-.TP
-~/.config/monkeysphere/user_keys
-User keys cache directory.
-.TP
-~/.config/monkeysphere/host_keys
-Host keys cache directory.
 
 .SH AUTHOR
 
index eafd6a8d7416124c94fb7dd72b56235090fcd109..5ca248ae84cf74e9442421db5f3d4e9e694a6900 100644 (file)
@@ -24,8 +24,11 @@ be used for authentication and encryption of ssh connection.
 .B update-users [USER]...
 Update the admin-controlled authorized_keys files for user.  For each
 user specified, update the user's authorized_keys file in
-/var/cache/monkeysphere/USER.  See `man monkeysphere' for more info.
-`k' may be used in place of `update-known_hosts'.
+/var/cache/monkeysphere/authorized_keys/USER.  See `man monkeysphere'
+for more info.  If the USER_CONTROLLED_AUTHORIZED_KEYS variable is
+set, then a user-controlled authorized_keys file (usually
+~USER/.ssh/authorized_keys) is added to the authorized_keys file.  `k'
+may be used in place of `update-known_hosts'.
 .TP
 .B gen-key
 Generate a gpg key for the host.  `g' may be used in place of
@@ -66,8 +69,8 @@ Monkeysphere GNUPG home directory.
 /etc/monkeysphere/authorized_user_ids/USER
 Server maintained authorized_user_ids files for users.
 .TP
-/var/cache/monkeysphere/USER
-User keys cache directories.
+/var/cache/monkeysphere/authorized_keys/USER
+User authorized_keys file.
 
 .SH AUTHOR
 
index d1554a62c23ae9f44746d1e1114c0178d1d68f6a..7a904534d4f9b3fb1302dd7b30b1612923d69916 100644 (file)
 # file) and are considered global
 
 ########################################################################
+### COMMON VARIABLES
+
 # managed directories
 ETC="/etc/monkeysphere"
 export ETC
 CACHE="/var/cache/monkeysphere"
 export CACHE
+
 ########################################################################
+### UTILITY FUNCTIONS
 
 failure() {
     echo "$1" >&2
@@ -29,6 +33,10 @@ log() {
     echo "$@" 1>&2
 }
 
+loge() {
+    echo "$@" 1>&2
+}
+
 # cut out all comments(#) and blank lines from standard input
 meat() {
     grep -v -e "^[[:space:]]*#" -e '^$'
@@ -39,72 +47,89 @@ cutline() {
     head --line="$1" | tail -1
 }
 
-# retrieve all keys with given user id from keyserver
-# FIXME: need to figure out how to retrieve all matching keys
-# (not just first 5)
-gpg_fetch_userid() {
-    local userID
-
-    userID="$1"
-
-    log "checking keyserver $KEYSERVER..."
-    echo 1,2,3,4,5 | \
-       gpg --quiet --batch --command-fd 0 --with-colons \
-       --keyserver "$KEYSERVER" \
-       --search ="$userID" >/dev/null 2>&1
-    if [ "$?" = 0 ] ; then
-       log "  user ID found on keyserver."
-       return 0
-    else
-       log "  user ID not found on keyserver."
-       return 1
-    fi
-}
-
 # check that characters are in a string (in an AND fashion).
 # used for checking key capability
 # check_capability capability a [b...]
 check_capability() {
-    local capability
+    local usage
     local capcheck
 
-    capability="$1"
+    usage="$1"
     shift 1
 
     for capcheck ; do
-       if echo "$capability" | grep -q -v "$capcheck" ; then
+       if echo "$usage" | grep -q -v "$capcheck" ; then
            return 1
        fi
     done
     return 0
 }
 
-# get the full fingerprint of a key ID
-get_key_fingerprint() {
+# convert escaped characters from gpg output back into original
+# character
+# FIXME: undo all escape character translation in with-colons gpg output
+unescape() {
+    echo "$1" | sed 's/\\x3a/:/'
+}
+
+# remove all lines with specified string from specified file
+remove_file_line() {
+    local file
+    local string
+
+    file="$1"
+    string="$2"
+
+    if [ "$file" -a "$string" ] ; then
+       grep -v "$string" "$file" | sponge "$file"
+    fi
+}
+
+### CONVERTION UTILITIES
+
+# output the ssh key for a given key ID
+gpg2ssh() {
     local keyID
+    
+    #keyID="$1" #TMP
+    # only use last 16 characters until openpgp2ssh can take all 40 #TMP
+    keyID=$(echo "$1" | cut -c 25-) #TMP
 
-    keyID="$1"
+    gpg --export "$keyID" | openpgp2ssh "$keyID" 2> /dev/null
+}
 
-    gpg --list-key --with-colons --fixed-list-mode \
-       --with-fingerprint "$keyID" | grep "$keyID" | \
-       grep '^fpr:' | cut -d: -f10
+# output known_hosts line from ssh key
+ssh2known_hosts() {
+    local host
+    local key
+
+    host="$1"
+    key="$2"
+
+    echo -n "$host "
+    echo -n "$key" | tr -d '\n'
+    echo " MonkeySphere${DATE}"
 }
 
+# output authorized_keys line from ssh key
+ssh2authorized_keys() {
+    local userID
+    local key
+    
+    userID="$1"
+    key="$2"
 
-# convert escaped characters from gpg output back into original
-# character
-# FIXME: undo all escape character translation in with-colons gpg output
-unescape() {
-    echo "$1" | sed 's/\\x3a/:/'
+    echo -n "$key" | tr -d '\n'
+    echo " MonkeySphere${DATE}: ${userID}"
 }
 
 # convert key from gpg to ssh known_hosts format
 gpg2known_hosts() {
-    local keyID
     local host
+    local keyID
 
-    keyID="$1"
-    host=$(echo "$2" | sed -e "s|ssh://||")
+    host="$1"
+    keyID="$2"
 
     # NOTE: it seems that ssh-keygen -R removes all comment fields from
     # all lines in the known_hosts file.  why?
@@ -112,52 +137,88 @@ gpg2known_hosts() {
     # following regexp:
     # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
     echo -n "$host "
-    gpg --export "$keyID" | \
-       openpgp2ssh "$keyID" | tr -d '\n'
+    gpg2ssh "$keyID" | tr -d '\n'
     echo " MonkeySphere${DATE}"
 }
 
 # convert key from gpg to ssh authorized_keys format
 gpg2authorized_keys() {
+    local userID
     local keyID
+
+    userID="$1"
+    keyID="$2"
+
+    # NOTE: just in case, the COMMENT can be matched with the
+    # following regexp:
+    # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
+    gpg2ssh "$keyID" | tr -d '\n'
+    echo " MonkeySphere${DATE}: ${userID}"
+}
+
+### GPG UTILITIES
+
+# retrieve all keys with given user id from keyserver
+# FIXME: need to figure out how to retrieve all matching keys
+# (not just first N (5 in this case))
+gpg_fetch_userid() {
     local userID
 
+    userID="$1"
+
+    log -n " checking keyserver $KEYSERVER... "
+    echo 1,2,3,4,5 | \
+       gpg --quiet --batch --with-colons \
+       --command-fd 0 --keyserver "$KEYSERVER" \
+       --search ="$userID" > /dev/null 2>&1
+    loge "done."
+}
+
+# get the full fingerprint of a key ID
+get_key_fingerprint() {
+    local keyID
+
     keyID="$1"
-    userID="$2"
 
-    gpg --export "$keyID" | \
-       openpgp2ssh "$keyID" | tr -d '\n'
-    echo " MonkeySphere${DATE}: ${userID}"
+    gpg --list-key --with-colons --fixed-list-mode \
+       --with-fingerprint "$keyID" | grep "$keyID" | \
+       grep '^fpr:' | cut -d: -f10
 }
 
+########################################################################
+### PROCESSING FUNCTIONS
+
 # userid and key policy checking
 # the following checks policy on the returned keys
 # - checks that full key has appropriate valididy (u|f)
 # - checks key has specified capability (REQUIRED_*_KEY_CAPABILITY)
-# - checks that particular desired user id has appropriate validity
-# see /usr/share/doc/gnupg/DETAILS.gz
+# - checks that requested user ID has appropriate validity
+# (see /usr/share/doc/gnupg/DETAILS.gz)
+# output is one line for every found key, in the following format:
+#
+# flag fingerprint
+#
+# "flag" is an acceptability flag, 0 = ok, 1 = bad
+# "fingerprint" is the fingerprint of the key
+#
 # expects global variable: "MODE"
 process_user_id() {
     local userID
-    local cacheDir
     local requiredCapability
     local requiredPubCapability
     local gpgOut
-    local line
     local type
     local validity
     local keyid
     local uidfpr
-    local capability
+    local usage
     local keyOK
-    local pubKeyID
     local uidOK
-    local keyIDs
-    local userIDHash
-    local keyID
+    local lastKey
+    local lastKeyOK
+    local fingerprint
 
     userID="$1"
-    cacheDir="$2"
 
     # set the required key capability based on the mode
     if [ "$MODE" = 'known_hosts' ] ; then
@@ -174,126 +235,120 @@ process_user_id() {
     fi
 
     # output gpg info for (exact) userid and store
-    gpgOut=$(gpg --fixed-list-mode --list-key --with-colons \
-       ="$userID" 2> /dev/null)
-
-    # return 1 if there only "tru" lines are output from gpg
-    if [ -z "$(echo "$gpgOut" | grep -v '^tru:')" ] ; then
-       log "  key not found in keychain."
-       return 1
+    gpgOut=$(gpg --list-key --fixed-list-mode --with-colon \
+       --with-fingerprint --with-fingerprint \
+       ="$userID" 2>/dev/null)
+
+    # if the gpg query return code is not 0, return 1
+    if [ "$?" -ne 0 ] ; then
+        log "  - key not found."
+        return 1
     fi
 
     # loop over all lines in the gpg output and process.
     # need to do it this way (as opposed to "while read...") so that
     # variables set in loop will be visible outside of loop
-    for line in $(seq 1 $(echo "$gpgOut" | wc -l)) ; do
-
-       # read the contents of the line
-       type=$(echo "$gpgOut" | cutline "$line" | cut -d: -f1)
-       validity=$(echo "$gpgOut" | cutline "$line" | cut -d: -f2)
-       keyid=$(echo "$gpgOut" | cutline "$line" | cut -d: -f5)
-       uidfpr=$(echo "$gpgOut" | cutline "$line" | cut -d: -f10)
-       capability=$(echo "$gpgOut" | cutline "$line" | cut -d: -f12)
-
+    echo "$gpgOut" | cut -d: -f1,2,5,10,12 | \
+    while IFS=: read -r type validity keyid uidfpr usage ; do
        # process based on record type
        case $type in
            'pub') # primary keys
                # new key, wipe the slate
                keyOK=
-               pubKeyID=
                uidOK=
-               keyIDs=
+               lastKey=pub
+               lastKeyOK=
+               fingerprint=
 
-               pubKeyID="$keyid"
+               log " primary key found: $keyid"
 
-               # check primary key validity
+               # if overall key is not valid, skip
                if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
-                   log "  unacceptable primary key validity ($validity)."
+                   log "  unacceptable primary key validity ($validity)."
                    continue
                fi
-               # check capability is not Disabled...
-               if check_capability "$capability" 'D' ; then
-                   log "  key disabled."
+               # if overall key is disabled, skip
+               if check_capability "$usage" 'D' ; then
+                   log "  key disabled."
                    continue
                fi
-               # check overall key capability
-               # must be Encryption and Authentication
-               if ! check_capability "$capability" $requiredPubCapability ; then
-                   log "  unacceptable primary key capability ($capability)."
+               # if overall key capability is not ok, skip
+               if ! check_capability "$usage" $requiredPubCapability ; then
+                   log "  - unacceptable primary key capability ($usage)."
                    continue
                fi
 
-               # mark if primary key is acceptable
+               # mark overall key as ok
                keyOK=true
 
-               # add primary key ID to key list if it has required capability
-               if check_capability "$capability" $requiredCapability ; then
-                   keyIDs[${#keyIDs[*]}]="$keyid"
+               # mark primary key as ok if capability is ok
+               if check_capability "$usage" $requiredCapability ; then
+                   lastKeyOK=true
                fi
                ;;
            'uid') # user ids
-               # check key ok and we have key fingerprint
-               if [ -z "$keyOK" ] ; then
+               # if an acceptable user ID was already found, skip
+               if [ "$uidOK" ] ; then
                    continue
                fi
-               # check key validity
-               if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
+               # if the user ID does not match, skip
+               if [ "$(unescape "$uidfpr")" != "$userID" ] ; then
                    continue
                fi
-               # check the uid matches
-               if [ "$(unescape "$uidfpr")" != "$userID" ] ; then
+               # if the user ID validity is not ok, skip
+               if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
                    continue
                fi
 
-               # mark if uid acceptable
+               # mark user ID acceptable
                uidOK=true
+
+               # output a line for the primary key
+               # 0 = ok, 1 = bad
+               if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
+                   log "  * acceptable key found."
+                   echo 0 "$fingerprint"
+               else
+                   echo 1 "$fingerprint"
+               fi
                ;;
            'sub') # sub keys
-               # add sub key ID to key list if it has required capability
-               if check_capability "$capability" $requiredCapability ; then
-                   keyIDs[${#keyIDs[*]}]="$keyid"
+               # unset acceptability of last key
+               lastKey=sub
+               lastKeyOK=
+               fingerprint=
+
+               # if sub key validity is not ok, skip
+               if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
+                   continue
+               fi
+               # if sub key capability is not ok, skip
+               if ! check_capability "$usage" $requiredCapability ; then
+                   continue
                fi
+
+               # mark sub key as ok
+               lastKeyOK=true
                ;;
-       esac
-    done
+           'fpr') # key fingerprint
+               fingerprint="$uidfpr"
 
-    # hash userid for cache file name
-    userIDHash=$(echo "$userID" | sha1sum | awk '{ print $1 }')
-
-    # make sure the cache directory exists
-    mkdir -p "$cacheDir"
-
-    # touch/clear key cache file
-    # (will be left empty if there are noacceptable keys)
-    > "$cacheDir"/"$userIDHash"."$pubKeyID"
-
-    # for each acceptable key, write an ssh key line to the
-    # key cache file
-    if [ "$keyOK" -a "$uidOK" -a "${keyIDs[*]}" ] ; then
-       for keyID in ${keyIDs[@]} ; do
-           log "  acceptable key/userID found."
-
-           if [ "$MODE" = 'known_hosts' ] ; then
-               # export the key
-               gpg2known_hosts "$keyID" "$userID" >> \
-                   "$cacheDir"/"$userIDHash"."$pubKeyID"
-               # hash the cache file if specified
-               if [ "$HASH_KNOWN_HOSTS" = "true" ] ; then
-                   ssh-keygen -H -f "$cacheDir"/"$userIDHash"."$pubKeyID" > /dev/null 2>&1
-                   rm "$cacheDir"/"$userIDHash"."$pubKeyID".old
+               # if the last key was the pub key, skip
+               if [ "$lastKey" = pub ] ; then
+                   continue
                fi
-           elif [ "$MODE" = 'authorized_keys' ] ; then
-               # export the key
-                # FIXME: needs to apply extra options for authorized_keys
-               # lines if specified
-               gpg2authorized_keys "$keyID" "$userID" >> \
-                   "$cacheDir"/"$userIDHash"."$pubKeyID"
-           fi
-       done
-    fi
-
-    # echo the path to the key cache file
-    echo "$cacheDir"/"$userIDHash"."$pubKeyID"
+               
+               # output a line for the last subkey
+               # 0 = ok, 1 = bad
+               if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
+                   log "  * acceptable key found."
+                   echo 0 "$fingerprint"
+               else
+                   echo 1 "$fingerprint"
+               fi
+               ;;
+       esac
+    done
 }
 
 # update the cache for userid, and prompt to add file to
@@ -301,32 +356,25 @@ process_user_id() {
 # and not already in file.
 update_userid() {
     local userID
-    local cacheDir
-    local keyCache
 
     userID="$1"
-    cacheDir="$2"
 
     log "processing userid: '$userID'"
 
-    # return 1 if there is no output of the user ID processing
-    # ie. no key was found
-    keyCachePath=$(process_user_id "$userID" "$cacheDir")
-    if [ -z "$keyCachePath" ] ; then
-       return 1
-    fi
+    # process the user ID to pull it from keyserver
+    process_user_id "$userID" | grep -q "^0 "
 
     # check if user ID is in the authorized_user_ids file
     if ! grep -q "^${userID}\$" "$AUTHORIZED_USER_IDS" ; then
        read -p "user ID not currently authorized.  authorize? [Y|n]: " OK; OK=${OK:=Y}
        if [ ${OK/y/Y} = 'Y' ] ; then
            # add if specified
-           log -n "adding user ID to authorized_user_ids file... "
+           log -n " adding user ID to authorized_user_ids file... "
            echo "$userID" >> "$AUTHORIZED_USER_IDS"
-           echo "done."
+           loge "done."
        else
            # else do nothing
-           log "authorized_user_ids file untouched."
+           log " authorized_user_ids file untouched."
        fi
     fi
 }
@@ -339,145 +387,143 @@ remove_userid() {
 
     log "processing userid: '$userID'"
 
+    # check if user ID is in the authorized_user_ids file
     if ! grep -q "^${userID}\$" "$AUTHORIZED_USER_IDS" ; then
-       log "user ID not currently authorized."
+       log " user ID not currently authorized."
        return 1
     fi
 
-    log -n "removing user ID '$userID'... "
-    grep -v "$userID" "$AUTHORIZED_USER_IDS" | sponge "$AUTHORIZED_USER_IDS"
-    echo "done."
+    # remove user ID from file
+    log -n " removing user ID '$userID'... "
+    remove_file_line "$AUTHORIZED_USER_IDS" "^${userID}$"
+    loge "done."
 }
 
-# process a host for addition to a known_host file
-process_host() {
+# process a host in known_host file
+process_host_known_hosts() {
     local host
-    local cacheDir
-    local keyCachePath
+    local userID
+    local ok
+    local keyid
+    local tmpfile
 
     host="$1"
-    cacheDir="$2"
+    userID="ssh://${host}"
 
     log "processing host: $host"
 
-    keyCachePath=$(process_user_id "ssh://${host}" "$cacheDir")
-    if [ $? = 0 ] ; then
-       ssh-keygen -R "$host" -f "$USER_KNOWN_HOSTS"
-       cat "$keyCachePath" >> "$USER_KNOWN_HOSTS"
-    fi
+    process_user_id "ssh://${host}" | \
+    while read -r ok keyid ; do
+       sshKey=$(gpg2ssh "$keyid")
+       # remove the old host key line
+       remove_file_line "$KNOWN_HOSTS" "$sshKey"
+       # if key OK, add new host line
+       if [ "$ok" -eq '0' ] ; then
+           # hash if specified
+           if [ "$HASH_KNOWN_HOSTS" = 'true' ] ; then
+               # FIXME: this is really hackish cause ssh-keygen won't
+               # hash from stdin to stdout
+               tmpfile=$(mktemp)
+               ssh2known_hosts "$host" "$sshKey" > "$tmpfile"
+               ssh-keygen -H -f "$tmpfile" 2> /dev/null
+               cat "$tmpfile" >> "$KNOWN_HOSTS"
+               rm -f "$tmpfile" "${tmpfile}.old"
+           else
+               ssh2known_hosts "$host" "$sshKey" >> "$KNOWN_HOSTS"
+           fi
+       fi
+    done
+}
+
+# process a uid in an authorized_keys file
+process_uid_authorized_keys() {
+    local userID
+    local ok
+    local keyid
+
+    userID="$1"
+
+    log "processing user ID: $userID"
+
+    process_user_id "$userID" | \
+    while read -r ok keyid ; do
+       sshKey=$(gpg2ssh "$keyid")
+       # remove the old host key line
+       remove_file_line "$AUTHORIZED_KEYS" "$sshKey"
+       # if key OK, add new host line
+       if [ "$ok" -eq '0' ] ; then
+           ssh2authorized_keys "$userID" "$sshKey" >> "$AUTHORIZED_KEYS"
+       fi
+    done
 }
 
 # process known_hosts file
 # go through line-by-line, extract each host, and process with the
 # host processing function
 process_known_hosts() {
-    local cacheDir
     local hosts
     local host
 
-    cacheDir="$1"
-
     # take all the hosts from the known_hosts file (first field),
     # grep out all the hashed hosts (lines starting with '|')...
-    meat "$USER_KNOWN_HOSTS" | cut -d ' ' -f 1 | grep -v '^|.*$' | \
+    cat "$KNOWN_HOSTS" | meat | \
+       cut -d ' ' -f 1 | grep -v '^|.*$' | \
     while IFS=, read -r -a hosts ; do
-       # ...and process each host
+       # and process each host
        for host in ${hosts[*]} ; do
-           process_host "$host" "$cacheDir"
+           process_host_known_hosts "$host"
        done
     done
 }
 
-# update an authorized_keys file after first processing the 
-# authorized_user_ids file
-update_authorized_keys() {
-    local msAuthorizedKeys
-    local userAuthorizedKeys
-    local cacheDir
-
-    msAuthorizedKeys="$1"
-    userAuthorizedKeys="$2"
-    cacheDir="$3"
-
-    process_authorized_ids "$AUTHORIZED_USER_IDS" "$cacheDir"
-
-    # write output key file
-    log "writing monkeysphere authorized_keys file... "
-    touch "$msAuthorizedKeys"
-    if [ "$(ls "$cacheDir")" ] ; then
-       log -n "adding gpg keys... "
-       cat "$cacheDir"/* > "$msAuthorizedKeys"
-       echo "done."
-    else
-       log "no gpg keys to add."
-    fi
-    if [ "$userAuthorizedKeys" != "-" -a -s "$userAuthorizedKeys" ] ; then
-       log -n "adding user authorized_keys file... "
-       cat "$userAuthorizedKeys" >> "$msAuthorizedKeys"
-       echo "done."
-    fi
-    log "monkeysphere authorized_keys file generated:"
-    log "$msAuthorizedKeys"
-}
-
-# process an authorized_*_ids file
-# go through line-by-line, extract each userid, and process
-process_authorized_ids() {
-    local authorizedIDs
-    local cacheDir
-    local userID
-
-    authorizedIDs="$1"
-    cacheDir="$2"
+# process an authorized_user_ids file for authorized_keys
+process_authorized_user_ids() {
+    local userid
 
-    # clean out keys file and remake keys directory
-    rm -rf "$cacheDir"
-    mkdir -p "$cacheDir"
-
-    # loop through all user ids in file
-    # FIXME: needs to handle authorized_keys options
-    cat "$authorizedIDs" | meat | \
-    while read -r userID ; do
-       # process the userid
-       log "processing userid: '$userID'"
-       process_user_id "$userID" "$cacheDir" > /dev/null
+    cat "$AUTHORIZED_USER_IDS" | meat | \
+    while read -r userid ; do
+       process_uid_authorized_keys "$userid"
     done
 }
 
 # EXPERIMENTAL (unused) process userids found in authorized_keys file
 # go through line-by-line, extract monkeysphere userids from comment
 # fields, and process each userid
+# NOT WORKING
 process_authorized_keys() {
     local authorizedKeys
-    local cacheDir
     local userID
 
     authorizedKeys="$1"
-    cacheDir="$2"
 
     # take all the monkeysphere userids from the authorized_keys file
     # comment field (third field) that starts with "MonkeySphere uid:"
     # FIXME: needs to handle authorized_keys options (field 0)
-    cat "$authorizedKeys" | \
+    cat "$authorizedKeys" | meat | \
     while read -r options keytype key comment ; do
        # if the comment field is empty, assume the third field was
        # the comment
        if [ -z "$comment" ] ; then
            comment="$key"
        fi
-       if ! echo "$comment" | grep '^MonkeySphere userID:.*$' ; then
+
+       if echo "$comment" | egrep -v -q '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}:' ; then
            continue
        fi
-       userID=$(echo "$comment" | sed -e "/^MonkeySphere userID://")
+       userID=$(echo "$comment" | awk "{ print $2 }")
        if [ -z "$userID" ] ; then
            continue
        fi
+
        # process the userid
        log "processing userid: '$userID'"
-       process_user_id "$userID" "$cacheDir" > /dev/null
+       process_user_id "$userID" > /dev/null
     done
 }
 
+##################################################
+### GPG HELPER FUNCTIONS
+
 # retrieve key from web of trust, and set owner trust to "full"
 # if key is found.
 trust_key() {
index 230de06839e54f82f3392a128de135de86546cf7..6853f581ff2ff1b81083ed385ba3566326be7f32 100755 (executable)
@@ -53,7 +53,7 @@ gen_subkey(){
 
     keyID="$1"
 
-    gpgOut=$(gpg --fixed-list-mode --list-keys --with-colons \
+    gpgOut=$(gpg --quiet --fixed-list-mode --list-keys --with-colons \
        "$keyID" 2> /dev/null)
 
     # return 1 if there only "tru" lines are output from gpg
@@ -90,8 +90,9 @@ save
 EOF
 )
 
-    echo "generating subkey..."
+    log "generating subkey..."
     echo "$editCommands" | gpg --expert --command-fd 0 --edit-key "$keyID"
+    log "done."
 }
 
 ########################################################################
@@ -116,25 +117,19 @@ KEYSERVER=${KEYSERVER:-"subkeys.pgp.net"}
 CHECK_KEYSERVER=${CHECK_KEYSERVER:="true"}
 REQUIRED_HOST_KEY_CAPABILITY=${REQUIRED_HOST_KEY_CAPABILITY:-"e a"}
 REQUIRED_USER_KEY_CAPABILITY=${REQUIRED_USER_KEY_CAPABILITY:-"a"}
-USER_CONTROLLED_AUTHORIZED_KEYS=${USER_CONTROLLED_AUTHORIZED_KEYS:-"${HOME}/.ssh/authorized_keys"}
-USER_KNOWN_HOSTS=${USER_KNOWN_HOSTS:-"${HOME}/.ssh/known_hosts"}
+KNOWN_HOSTS=${KNOWN_HOSTS:-"${HOME}/.ssh/known_hosts"}
+AUTHORIZED_KEYS=${AUTHORIZED_KEYS:-"${HOME}/.ssh/authorized_keys"}
 HASH_KNOWN_HOSTS=${HASH_KNOWN_HOSTS:-"true"}
 
 export GNUPGHOME
 
-# stagging locations
-hostKeysCacheDir="${MS_HOME}/host_keys"
-userKeysCacheDir="${MS_HOME}/user_keys"
-msAuthorizedKeys="${MS_HOME}/authorized_keys"
-
 # make sure gpg home exists with proper permissions
 mkdir -p -m 0700 "$GNUPGHOME"
 
 # make sure the user monkeysphere home directory exists
 mkdir -p -m 0700 "$MS_HOME"
-mkdir -p "$hostKeysCacheDir"
-mkdir -p "$userKeysCacheDir"
 touch "$AUTHORIZED_USER_IDS"
+touch "$AUTHORIZED_KEYS"
 
 case $COMMAND in
     'update-known_hosts'|'update-known-hosts'|'k')
@@ -142,23 +137,25 @@ case $COMMAND in
 
         # touch the known_hosts file to make sure it exists
        # ssh-keygen complains if it doesn't exist
-       touch "$USER_KNOWN_HOSTS"
+       touch "$KNOWN_HOSTS"
 
         # if hosts are specified on the command line, process just
         # those hosts
        if [ "$1" ] ; then
             for host ; do
-               process_host "$host" "$hostKeysCacheDir"
+               process_host_known_hosts "$host"
            done
+           log "known_hosts file updated."
 
         # otherwise, if no hosts are specified, process every user
         # in the user's known_hosts file
        else
-           if [ ! -s "$USER_KNOWN_HOSTS" ] ; then
-               failure "known_hosts file '$USER_KNOWN_HOSTS' is empty."
+           if [ ! -s "$KNOWN_HOSTS" ] ; then
+               failure "known_hosts file '$KNOWN_HOSTS' is empty."
            fi
            log "processing known_hosts file..."
-           process_known_hosts "$hostKeysCacheDir"
+           process_known_hosts
+           log "known_hosts file updated."
        fi
        ;;
 
@@ -167,7 +164,7 @@ case $COMMAND in
            failure "you must specify at least one userid."
        fi
        for userID ; do
-           update_userid "$userID" "$userKeysCacheDir"
+           update_userid "$userID"
        done
        log "Run the following to update your monkeysphere authorized_keys file:"
        log "$PGRM update-authorized_keys"
@@ -192,8 +189,10 @@ case $COMMAND in
            failure "$AUTHORIZED_USER_IDS is empty."
        fi
 
-       # update authorized_keys
-       update_authorized_keys "$msAuthorizedKeys" "$USER_CONTROLLED_AUTHORIZED_KEYS" "$userKeysCacheDir"
+       # process authorized_user_ids file
+       log "processing authorized_user_ids file..."
+       process_authorized_user_ids
+       log "authorized_keys file updated."
        ;;
 
     'gen-subkey'|'g')
index 6279c4561a324fc40dc7a358df409ef9bb06056c..560d249867d780183f9b070ed341c099bf948963 100755 (executable)
@@ -106,7 +106,7 @@ EOF
 
     log -n "generating server key... "
     echo "$keyParameters" | gpg --batch --gen-key
-    echo "done."
+    loge "done."
 }
 
 ########################################################################
@@ -127,20 +127,25 @@ MS_CONF=${MS_CONF:-"$MS_HOME"/monkeysphere-server.conf}
 # set empty config variable with defaults
 GNUPGHOME=${GNUPGHOME:-"${MS_HOME}/gnupg"}
 KEYSERVER=${KEYSERVER:-"subkeys.pgp.net"}
+CHECK_KEYSERVER=${CHECK_KEYSERVER:="true"}
 REQUIRED_USER_KEY_CAPABILITY=${REQUIRED_USER_KEY_CAPABILITY:-"a"}
 USER_CONTROLLED_AUTHORIZED_KEYS=${USER_CONTROLLED_AUTHORIZED_KEYS:-"%h/.ssh/authorized_keys"}
 
 export GNUPGHOME
 
+# make sure the monkeysphere home directory exists
+mkdir -p "${MS_HOME}/authorized_user_ids"
 # make sure gpg home exists with proper permissions
 mkdir -p -m 0700 "$GNUPGHOME"
+# make sure the authorized_keys directory exists
+mkdir -p "${CACHE}/authorized_keys"
 
 case $COMMAND in
     'update-users'|'update-user'|'s')
        if [ "$1" ] ; then
            unames="$@"
        else
-           unames=$(ls -1 "$MS_HOME"/authorized_user_ids)
+           unames=$(ls -1 "${MS_HOME}/authorized_user_ids")
        fi
 
        for uname in $unames ; do
@@ -149,12 +154,14 @@ case $COMMAND in
            log "----- user: $uname -----"
 
            # set variables for the user
-           AUTHORIZED_USER_IDS="$MS_HOME"/authorized_user_ids/"$uname"
-           msAuthorizedKeys="$CACHE"/"$uname"/authorized_keys
-           cacheDir="$CACHE"/"$uname"/user_keys
+           AUTHORIZED_USER_IDS="${MS_HOME}/authorized_user_ids/${uname}"
+           # temporary authorized_keys file
+           AUTHORIZED_KEYS="${CACHE}/authorized_keys/${uname}.tmp"
 
             # make sure user's authorized_user_ids file exists
            touch "$AUTHORIZED_USER_IDS"
+           # make sure the authorized_keys file exists and is clear
+           > "$AUTHORIZED_KEYS"
 
            # skip if the user's authorized_user_ids file is empty
            if [ ! -s "$AUTHORIZED_USER_IDS" ] ; then
@@ -162,14 +169,23 @@ case $COMMAND in
                continue
            fi
 
-           # set user-controlled authorized_keys file path
-           if [ "$USER_CONTROLLED_AUTHORIZED_KEYS" ] ; then
+           # process authorized_user_ids file
+           log "processing authorized_user_ids file..."
+           process_authorized_user_ids
+
+           # add user-controlled authorized_keys file path if specified
+           if [ "$USER_CONTROLLED_AUTHORIZED_KEYS" != '-' ] ; then
                userHome=$(getent passwd "$uname" | cut -d: -f6)
                userAuthorizedKeys=${USER_CONTROLLED_AUTHORIZED_KEYS/\%h/"$userHome"}
+               log -n "adding user's authorized_keys file... "
+               cat "$userAuthorizedKeys" >> "$AUTHORIZED_KEYS"
+               loge "done."
            fi
 
-           # update authorized_keys
-           update_authorized_keys "$msAuthorizedKeys" "$userAuthorizedKeys" "$cacheDir"
+           # move the temp authorized_keys file into place
+           mv -f "${CACHE}/authorized_keys/${uname}.tmp" "${CACHE}/authorized_keys/${uname}"
+
+           log "authorized_keys file updated."
        done
 
        log "----- done. -----"
@@ -206,14 +222,13 @@ case $COMMAND in
 
        # set variables for the user
        AUTHORIZED_USER_IDS="$MS_HOME"/authorized_user_ids/"$uname"
-       cacheDir="$CACHE"/"$uname"/user_keys
 
         # make sure user's authorized_user_ids file exists
        touch "$AUTHORIZED_USER_IDS"
 
        # process the user IDs
        for userID ; do
-           update_userid "$userID" "$cacheDir"
+           update_userid "$userID"
        done
 
        log "Run the following to update user's authorized_keys file:"
index 3887e4897d10eca20c7234761ae3e1451238c68c..4b90a0d21fe5e884335a43e277c96473d760c45c 100755 (executable)
@@ -44,6 +44,8 @@ hostKey=$(ssh-keygen -F "$HOST")
 # don't check the keyserver
 if [ "$hostKey" ] ; then
     CHECK_KEYSERVER="false"
+else
+    CHECK_KEYSERVER="true"
 fi
 export CHECK_KEYSERVER
 
diff --git a/src/seckey2sshagent b/src/seckey2sshagent
new file mode 100755 (executable)
index 0000000..0e8d695
--- /dev/null
@@ -0,0 +1,25 @@
+#!/bin/sh
+
+cleanup() {
+    echo -n "removing temp gpg home... "
+    rm -rf $FOO
+    echo "done."
+}
+
+trap cleanup EXIT
+
+GPGID="$1"
+
+idchars=$(echo $GPGID | wc -m)
+if [ "$idchars" -ne 17 ] ; then
+    echo "GPGID is not 16 characters ($idchars)."
+    exit 1
+fi
+
+FOO=$(mktemp -d)
+
+gpg --export-secret-key --export-options export-reset-subkey-passwd $GPGID | GNUPGHOME=$FOO gpg --import
+
+GNUPGHOME=$FOO gpg --edit-key $GPGID
+
+GNUPGHOME=$FOO gpg --export-secret-key $GPGID | openpgp2ssh $GPGID | ssh-add -c /dev/stdin